package lilivel.b4a.libtest;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "lilivel.b4a.libtest", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "lilivel.b4a.libtest", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 14;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 15;BA.debugLine="Activity.LoadLayout(\"Main\")";
Debug.ShouldStop(16384);
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 BA.debugLineNum = 16;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 22;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 24;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 18;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(131072);
 BA.debugLineNum = 20;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button1_click() throws Exception{
		Debug.PushSubsStack("Button1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
lilivel.b4a.miscUtil.miscUtil _mu = null;
anywheresoftware.b4a.phone.ContactsWrapper.Contact _c = null;
String _name = "";
String _phonenr = "";
int _phonetype = 0;
String _mail = "";
int _mailtype = 0;
anywheresoftware.b4a.phone.ContactsWrapper _cs = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
 BA.debugLineNum = 26;BA.debugLine="Sub Button1_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 29;BA.debugLine="Dim mu As miscUtil, c As Contact";
Debug.ShouldStop(268435456);
_mu = new lilivel.b4a.miscUtil.miscUtil();Debug.locals.put("mu", _mu);
_c = new anywheresoftware.b4a.phone.ContactsWrapper.Contact();Debug.locals.put("c", _c);
 BA.debugLineNum = 30;BA.debugLine="mu.Initialize";
Debug.ShouldStop(536870912);
_mu.Initialize(mostCurrent.activityBA);
 BA.debugLineNum = 31;BA.debugLine="Dim name As String, phoneNr As String, phoneType As Int, mail As String, mailType As Int";
Debug.ShouldStop(1073741824);
_name = "";Debug.locals.put("name", _name);
_phonenr = "";Debug.locals.put("phoneNr", _phonenr);
_phonetype = 0;Debug.locals.put("phoneType", _phonetype);
_mail = "";Debug.locals.put("mail", _mail);
_mailtype = 0;Debug.locals.put("mailType", _mailtype);
 BA.debugLineNum = 33;BA.debugLine="name = \"Mike Tester\"";
Debug.ShouldStop(1);
_name = "Mike Tester";Debug.locals.put("name", _name);
 BA.debugLineNum = 34;BA.debugLine="phoneNr = \"004912345678\"";
Debug.ShouldStop(2);
_phonenr = "004912345678";Debug.locals.put("phoneNr", _phonenr);
 BA.debugLineNum = 35;BA.debugLine="phoneType = c.PHONE_HOME";
Debug.ShouldStop(4);
_phonetype = _c.PHONE_HOME;Debug.locals.put("phoneType", _phonetype);
 BA.debugLineNum = 36;BA.debugLine="mail = \"mike@tester.com\"";
Debug.ShouldStop(8);
_mail = "mike@tester.com";Debug.locals.put("mail", _mail);
 BA.debugLineNum = 37;BA.debugLine="mailType = c.EMAIL_HOME";
Debug.ShouldStop(16);
_mailtype = _c.EMAIL_HOME;Debug.locals.put("mailType", _mailtype);
 BA.debugLineNum = 39;BA.debugLine="mu.createContactEntry(name, phoneNr, phoneType, mail, mailType)";
Debug.ShouldStop(64);
_mu.createContactEntry(_name,_phonenr,_phonetype,_mail,_mailtype);
 BA.debugLineNum = 43;BA.debugLine="Dim cs As Contacts";
Debug.ShouldStop(1024);
_cs = new anywheresoftware.b4a.phone.ContactsWrapper();Debug.locals.put("cs", _cs);
 BA.debugLineNum = 44;BA.debugLine="Dim l As List";
Debug.ShouldStop(2048);
_l = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("l", _l);
 BA.debugLineNum = 45;BA.debugLine="l = cs.GetAll";
Debug.ShouldStop(4096);
_l = _cs.GetAll();Debug.locals.put("l", _l);
 BA.debugLineNum = 46;BA.debugLine="For i = 0 To l.Size - 1";
Debug.ShouldStop(8192);
{
final double step24 = 1;
final double limit24 = (int)(_l.getSize()-1);
for (_i = (int)(0); (step24 > 0 && _i <= limit24) || (step24 < 0 && _i >= limit24); _i += step24) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 47;BA.debugLine="c = l.Get(i)";
Debug.ShouldStop(16384);
_c = (anywheresoftware.b4a.phone.ContactsWrapper.Contact)(_l.Get(_i));Debug.locals.put("c", _c);
 BA.debugLineNum = 48;BA.debugLine="Log(c)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.Log(String.valueOf(_c));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 51;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                if (mostCurrent != null) {
Debug.StartDebugging(mostCurrent.activityBA, 30799, new int[] {2} );}

		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 BA.debugLineNum = 12;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity};
}
}
